/* -*- Mode: C; c-file-style: "gnu" -*-
  snprintf.c -- if snprintf() is missing, make a replacement
  Created: Petter Reinholdtsen <pere@td.org.uit.no>, 1997-11-01
 */

/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1997, 1998 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#include "config.h"

#ifndef HAVE_SNPRINTF

#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>

int 
snprintf(char *string1, 
	 size_t size, 
	 const char *format,
	 ...)

{
  int result;
  va_list varlist;

  va_start(varlist, format);

  result = vsprintf(string1, format, varlist);

  va_end(varlist);

  return result;
}

#endif
