/* -*- Mode: C; c-file-style: "gnu" -*-
   constructor.c -- native methods for java/lang/reflect/Constructor
   Created: Chris Toshok <toshok@hungry.com>, 12-Feb-1998.
 */
/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1998 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
#include "jni.h"
#include "ClazzFile.h"
#include "objects.h"

JNIEXPORT jint JNICALL
Java_java_lang_reflect_Constructor_getModifiers(JNIEnv *env,
						jobject ctor)
{
  jint slot;
  jobject clazz;
  ClazzFile *cf;
  jclass ctor_class = (*env)->FindClass(env, "java/lang/reflect/Constructor");
  jfieldID slot_field = (*env)->GetFieldID(env, ctor_class, "slot", "I");
  jfieldID clazz_field = (*env)->GetFieldID(env, ctor_class, "clazz", "[java/lang/Class;");

  slot = (*env)->GetIntField(env, ctor, slot_field);
  clazz = (*env)->GetObjectField(env, ctor, clazz_field);

  cf = ((obj_thunk*)clazz)->_static;

  return cf->methods[slot]->access_flags;
}

JNIEXPORT jobject JNICALL
Java_java_lang_reflect_Constructor_newInstance(JNIEnv *env,
					       jobject ctor,
					       jobjectArray args)
{
  (*env)->FatalError(env, "java/lang/reflect/Constructor.newInstance() not implemented yet.");
  return NULL;
}
