/* -*- Mode: C; c-file-style: "gnu" -*-
   compiler.c -- native methods for java/lang/Compiler.
   Created: Chris Toshok <toshok@hungry.com>, 28-Jul-1997
 */
/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1997, 1998 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
#include "jni.h"

/*
 * Must read property java.compiler and env JAVA_COMPILER for name of
 * JIT compiler library.
 */

JNIEXPORT void JNICALL
Java_java_lang_Compiler_initialize(JNIEnv *env,
				   jclass cls)
{
  (*env)->FatalError(env, "Java_java_lang_Compiler_initialize not implemented.");
}

JNIEXPORT jboolean JNICALL
Java_java_lang_Compiler_compileClass(JNIEnv *env,
				     jclass cls)
{
  (*env)->FatalError(env, "Java_java_lang_Compiler_compileClass not implemented.");
  return JNI_FALSE;
}

JNIEXPORT jboolean JNICALL
Java_java_lang_Compiler_compileClasses(JNIEnv *env,
				       jclass cls,
				       jstring string)
{
  (*env)->FatalError(env, "Java_java_lang_Compiler_compileClasses not implemented.");
  return JNI_FALSE;
}

JNIEXPORT jobject JNICALL
Java_java_lang_Compiler_command(JNIEnv *env,
				jclass cls,
				jobject any)
{
  (*env)->FatalError(env, "Java_java_lang_Compiler_command not implemented.");
  return NULL;
}

JNIEXPORT void JNICALL
Java_java_lang_Compiler_enable(JNIEnv *env,
			       jclass cls)
{
  (*env)->FatalError(env, "Java_java_lang_Compiler_enable not implemented.");
}

JNIEXPORT void JNICALL
Java_java_lang_Compiler_disable(JNIEnv *env,
				jclass cls)
{
  (*env)->FatalError(env, "Java_java_lang_Compiler_disable not implemented.");
}
