/* -*- Mode: C; c-file-style: "gnu" -*-
   double.c -- native methods for java/lang/Double.
   Created: Chris Toshok <toshok@hungry.com>, 28-Jul-1997
 */
/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1997, 1998 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
#include "config.h"
#include "jni.h"

#include <stdlib.h>
#include <string.h>

JNIEXPORT jlong JNICALL
Java_java_lang_Double_doubleToLongBits(JNIEnv *env,
				       jclass cls,
				       jdouble value)
{
  jvalue jval;

  jval.d = value;
  return jval.j;
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Double_longBitsToDouble(JNIEnv *env,
				       jclass cls,
				       jlong bits)
{
  jvalue value;

  value.j = bits;
  return value.d;
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Double_valueOf0(JNIEnv *env,
			       jclass cls,
			       jstring string)
{
  jvalue value;
  const jbyte *string_chars;
  jint string_length;
  char *str;

  string_chars = (*env)->GetStringUTFChars(env, string, NULL);
  string_length = (*env)->GetStringUTFLength(env, string) + 1;
  str = (char*)malloc(string_length * sizeof(char));
  
  strncpy(str, (char*)string_chars, string_length);

  (*env)->ReleaseStringUTFChars(env, string, string_chars);

  value.j = atof(str);

  free(str);

  return value.d;
}
