/* -*- Mode: C; c-file-style: "gnu" -*-
   button.c -- native methods for sun/awt/motif/MButtonPeer..
   Created: Chris Toshok <toshok@hungry.com>, 1-Apr-1998.
 */
/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1998 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#include "jni.h"

#include "common.h"
#include <Xm/Xm.h>
#include <Xm/PushB.h>

#include <assert.h>
#include <stdlib.h>

void
Java_sun_awt_motif_MButtonPeer_create(JNIEnv *env,
				      jobject peer,
				      jobject parent_peer)
{
  Widget button;
  Widget parent;

  printf ("In Java_sun_awt_motif_MButtonPeer_create\n");

  assert(NULL != peer && NULL != parent_peer);

  parent = get_component_widget(env, parent_peer);

  LOCK_AWT();

  button = XmCreatePushButton(parent,
			      "button",
			      NULL, 0);

  UNLOCK_AWT();

  set_component_widget(env, peer, button);
}

void
Java_sun_awt_motif_MButtonPeer_setLabel(JNIEnv *env,
					jobject peer,
					jstring text)
{
  Widget widget = get_component_widget(env, peer);
  const jbyte *label_text = (*env)->GetStringUTFChars(env, text, NULL);
  XmString label_xmstring;

  printf ("In Java_sun_awt_motif_MButtonPeer_setLabel\n");

  LOCK_AWT();

  label_xmstring = XmStringCreate((char*)label_text, XmFONTLIST_DEFAULT_TAG);
  XtVaSetValues(widget,
		XmNlabelString, label_xmstring,
		NULL);

  XmStringFree(label_xmstring);

  UNLOCK_AWT();

  (*env)->ReleaseStringUTFChars(env, text, label_text);
}
